#!/bin/sh

cd ~/MergePrint

# Install the required packages for the project
pip install trl
pip install GPUtil

# Install the required packages for Instructional_Fingerprinting
cd Instructional_Fingerprinting
pip install -r requirements.txt

# Install the required packages for mergekit
cd ../mergekit
pip install -e .

# Install the required packages for lm-evaluation-harness
cd ../lm-evaluation-harness
pip install -e .

cd ~/MergePrint

# Set the environment variables for lm-evaluation-harness
export MASTER_ADDR=$(hostname -s)
export MASTER_PORT=29501
export HF_DATASETS_TRUST_REMOTE_CODE=1

export TRITON_CACHE_DIR=./triton_cache

# Set the number of GPUs
NUM_GPUS=$(nvidia-smi --query-gpu=name --format=csv,noheader | wc -l)
export WORLD_SIZE=$NUM_GPUS

# Login to Hugging Face to use the models in Hugging Face
huggingface-cli login --token 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
# Set the environment variables for W&B
export WANDB_API_KEY=2bb79ab788d19dfa14b62673ad9bcb042d829231